/***************************************************************************
                          sposixthread.h  -  description
                             -------------------
    begin                : Sun Mar 30 2003
    copyright            : (C) 2003 by Andre Stein
    email                : andre_stein@web.de
    url                  : www.steinsoft.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SPOSIXTHREAD_H
#define SPOSIXTHREAD_H

#define _REENTRANT

#include <pthread.h>

/**
  *@author Andre Stein
  */

class SPosixThread
{
public: 
	SPosixThread(void (*startFunction)() = 0);
	virtual ~SPosixThread();

	virtual void run();

	void stop(bool wait = true);
	bool start();
	void setRunFunction(void (*startFunction)());
protected:
	pthread_t thread;
	bool running;
	void (*threadStartFunction)();
};

#endif
